#include <iostream>
#include <string>
#include <fstream>

using namespace std;

int main(int argc, char *argv[])
{
	cout << "TraINShooter Mapparser by Deathlord\n\n";
	if(argc == 1)
	{
		cout << "No argument, quitting...\n";
		system("PAUSE");
		exit(0);	
	}
	else
	{
		cout << "Files to parse in batch queue: " << argc - 1 << "\n\nParsing files...\n\n";	
	}
	
	for(int i = 1; i < argc; ++i)
	{
		//open files
		
		ifstream ifile(argv[i], ios::in);
		if(!ifile)
			continue;
		string outputpath = argv[i];
		int len = outputpath.length();
		outputpath[len - 3] = 'm';
		outputpath[len - 2] = 'a';
		outputpath[len - 1] = 'p';
		ofstream ofile(outputpath.c_str(), ios::out | ios::trunc | ios::binary);
		
		//parse file
		//header
		int int_r;
		ifile >> int_r;
		int size_x = int_r;
		ofile.write((char*)&int_r, sizeof(int));
		ifile >> int_r;
		ofile.write((char*)&int_r, sizeof(int));
		ifile >> int_r;
		ofile.write((char*)&int_r, sizeof(int));
		ifile >> int_r;
		ofile.write((char*)&int_r, sizeof(int));
		ifile >> int_r;
		ofile.write((char*)&int_r, sizeof(int));
		ifile.ignore(1024, '\n');
		string str_r;
		getline(ifile, str_r, '\n');
		ofile.write(str_r.c_str(), str_r.length() + 1);
		
		//sections
		int last_section_found = 0;
		for(int i = 0; i < size_x / 20; ++i) //loop through sections
		{
			int section_nr_read = 0;
			ifile >> section_nr_read;
			int count = 0;
			while(section_nr_read > last_section_found + count) //fill with empty sections if some have been left out
			{
				++count;
				ofile.put(0);
				ofile.put(0);
			}
			last_section_found = section_nr_read + 1;
			
			int object_nr = 0;
			int enemy_nr = 0;
			ifile >> object_nr;
			ifile >> enemy_nr;
			ofile.put(object_nr);
			ofile.put(enemy_nr);
			
			if(object_nr == 255 && enemy_nr == 255) //special field
			{
				short shr_r;
				ifile >> shr_r;
				ofile.write((char*)&shr_r, sizeof(short));
			}
			else //normal section
			{
				for(int i = 0; i < object_nr; ++i)
				{
					ifile >> str_r;
					ofile.put(str_r[0]);
					for(int i = 0; i < 2; ++i)
					{
						ifile >> int_r;
						ofile.put(int_r);
					}
				}
				for(int i = 0; i < enemy_nr; ++i)
				{
					ifile >> str_r;
					ofile.put(str_r[0]);
					for(int i = 0; i < 3; ++i)
					{
						ifile >> int_r;
						ofile.put(int_r);
					}
				}
			}
			i += count;
		}
		ifile.close();
		ofile.close();
		cout << "\nCreating output from '" << argv[i] << "': " << outputpath << "\n";
	}
	cout << "\n\n-------------------------------------------------------------------------\nAll tasks finished.\n";
	//system("PAUSE");
    return 0;
}
