#include "StdAfx.h"
#include "bullet.h"
#include <fstream>

using namespace std;

asciibmp bulletPic;
	
void bullet::fill()
{
	object::fill();
	
	walk_haswaited = 0;	
	facing = 0;
	speed = 0;
	damage = 0;
	range = 0;
	owner = 0;
	if(bulletPic.getW() == 0)
	{
		bulletPic.create(1, 1);
		bulletPic.setPixel(0, 0, 'o', colors::white);
	}
	destroy_graphics = false;
	pic = &bulletPic;
	
	range_used = 0;
}

bullet::bullet(std::string objectfile)
{
	fill();
	load_objectfile(objectfile);
}

bullet::bullet(const bullet &from_blueprint, int posx, int posy, int _facing, int _owner)
{
	pic = from_blueprint.get_pic();
	destroy_graphics = false;
	pos[0] = posx;
	pos[1] = posy;
	facing = _facing;
	owner = _owner;
	pic = &bulletPic;
}

bullet::~bullet()
{
	if(destroy_graphics && pic)
	{
		delete pic;
		pic = 0;
	}
}

void bullet::write_objectfile(std::string to, std::string picpath, int speed, int damage, int range)
{
	ofstream file(to.c_str(), ios::out | ios::trunc | ios::binary);
	if(!file)
	{
		error::fatalError("Unable to write a file.", false);
		file.close();
		return;	
	}
	
	file.write((char*)&speed, sizeof(int));
	file.write((char*)&damage, sizeof(int));
	file.write((char*)&range, sizeof(int));
	file << picpath;
	file.close();	
}

void bullet::load_objectfile(std::string from)
{
	ifstream file(from.c_str());
	if(!file)
	{
		error::fatalError("Unable to open a file.", true);
		file.close();
		return;	
	}
	
	string picpath;
	getline(file, picpath, '\n');
	file >> speed >> damage >> range;
	pic = new asciibmp(picpath);
	destroy_graphics = true;
	
	file.close();		
}

asciibmp *bullet::get_pic() const
{
	return pic;
}

bool bullet::logic()
{
	walk_haswaited += 2;
	while(walk_haswaited >= speed)
	{
		++range_used;
		if(range_used >= range)
			return false;
		
		walk_haswaited -= speed;			
		pos[0] += move_pattern[facing][0];
		pos[1] += move_pattern[facing][1];
		
		if(pos[1] < 0)
			return false;
		if(pos[1] > 66)
			return false;
	}
	return true;
}
