#ifndef BULLET_H
#define BULLET_H

#include "object.h"

//NOTE: no blueprints for bullets (not neccessary as bullets are not hold by map file)
class bullet : public object
{
protected:
	int facing;
	int speed;
	int damage;
	int range;
	int range_used;
	int owner; //0: player 1: enemy
	
	void fill();
	int walk_haswaited;	

public:
	bullet() {fill();} //empty instance
	bullet(std::string objectfile); //make a bluepring (used at startup)
	bullet(const bullet &from_blueprint, int posx, int posy, int _facing, int _owner); //create a "real" instance from a blueprint instance
	virtual ~bullet();
	
	virtual void write_objectfile(std::string to, std::string picpath, int speed, int damage, int range); //picpath: no file extension
	virtual void load_objectfile(std::string from);
	
	bool logic(); //returns true if bullet is still flying, fals in case it reaches the end of its range. collision detection is done in game routine as well as destruction
	
	//setters / getters
	inline int get_facing() const {return facing;}
	inline int get_speed() const {return speed;}
	inline int get_damage() const {return damage;}
	inline int get_range() const {return range;}
	inline int get_owner() const {return owner;}
	
	asciibmp *get_pic() const;
	
	void set_facing(int v) {facing = v;}
	void set_speed(int v) {speed = v;}
	void set_damage(int v) {damage = v;}
	void set_range(int v) {range = v;}
	void set_owner(int v) {owner = v;}
};

#endif
