/*
  Name: Errors.h
  Copyright: Polecatsoft 2005
  Game: Tough Terry
  Author: Master Lenman
  Date: 16.07.05 14:43
  Description: This file contains the functions of the errors namespace,
	  that will show error messages for all kind of errors
*/

#ifndef HEADER_ERRORS
#define HEADER_ERRORS

#include <string>

namespace error
{
	//Error function that can be used for virtually everything
	void fatalError(std::string message, bool kill = true);

	//If Timer wasn't initialised
	void timerError(bool kill = true);

	//If there's no keyboard driver
	void keyboardError(bool kill = true);

	//No sounddriver found
	void soundDriverError(bool kill = true);

	//If no graphicmode could be entered
	void graphicModeError(bool kill = true);

	//create_bitmap failed
	void createError(bool kill = true);

	//load_bitmap failed
	void loadBitError(std::string name, bool kill = true);

	//load_datafile failed
	void datafileError(std::string name, bool kill = true);

	//loading a sound file failed
	void sampleLoadError(std::string sampleName, bool kill = true);

	//Loading the map failed
	void mapLoadError(std::string mapName, std::string reason, bool kill = true);

	//Error in mouse initialisation
	void mouseError(bool kill = true);
	
	//Error in network code
	void networkError(std::string errorMsg, bool kill = true);
}

#endif
